/*
 * vim:nomodifiable
 *
 * ************* DO NOT EDIT ***********************
 * This file is autogenerated from id_desc_list.c.m4
 * *************************************************
 */
/** @file
 * @brief HID report descriptor - usage ID description lists
 *
 * Copyright (C) 2010 Nikolai Kondrashov
 *
 * This file is part of hidrd.
 *
 * Hidrd is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Hidrd is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with hidrd; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * @author Nikolai Kondrashov <spbnick@gmail.com>
 */

#include <strings.h>
#include "hidrd/cfg.h"
#include "hidrd/util/tkn.h"
#include "hidrd/usage/all.h"
#include "hidrd/usage/id_desc_list.h"

bool
hidrd_usage_id_desc_list_valid(const hidrd_usage_id_desc   *list,
                               size_t                       num)
{
    if (list == NULL && num > 0)
        return false;

    for (; num > 0; list++, num--)
        if (!hidrd_usage_id_desc_valid(list))
            return false;

    return true;
}


const hidrd_usage_id_desc *
hidrd_usage_id_desc_list_lkp_by_value(const hidrd_usage_id_desc    *list,
                                      size_t                        num,
                                      hidrd_usage_id                value)
{
    assert(hidrd_usage_id_desc_list_valid(list, num));

    for (; num > 0; num--, list++)
        if (list->value == value)
            return list;

    return NULL;
}


#ifdef HIDRD_WITH_TOKENS
const hidrd_usage_id_desc *
hidrd_usage_id_desc_list_lkp_by_token(const hidrd_usage_id_desc    *list,
                                      size_t                        num,
                                      const char                   *token)
{
    assert(hidrd_usage_id_desc_list_valid(list, num));
    assert(hidrd_tkn_valid(token));

    for (; num > 0; num--, list++)
        if (strcasecmp(list->token, token) == 0)
            return list;

    return NULL;
}
#endif


#ifdef HIDRD_WITH_TOKENS
#define _U_TOKEN(_token)    .token = _token,
#else
#define _U_TOKEN(_token)
#endif

#ifdef HIDRD_WITH_NAMES
#define _U_NAME(_name)      .name = _name,
#else
#define _U_NAME(_name)
#endif

#define _U(_TOKEN, _token, _name, _type_set) \
    {.value = (hidrd_usage_id)HIDRD_USAGE_##_TOKEN, \
     .type_set  = _type_set,                        \
     _U_TOKEN(#_token) _U_NAME(_name)}

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_undefined[1] = {
    _U(UNDEFINED, undefined, "undefined", HIDRD_USAGE_TYPE_SET_EMPTY)
};
const hidrd_usage_id_desc   hidrd_usage_id_desc_list_desktop[71] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(DESKTOP_##_TOKEN, _token, _name, _type_set)

    _PU(POINTER, pointer,
        "pointer",
        HIDRD_USAGE_TYPE_CP),
    _PU(MOUSE, mouse,
        "mouse",
        HIDRD_USAGE_TYPE_CA),
    _PU(JOYSTICK, joystick,
        "joystick",
        HIDRD_USAGE_TYPE_CA),
    _PU(GAMEPAD, gamepad,
        "gamepad",
        HIDRD_USAGE_TYPE_CA),
    _PU(KEYBOARD, keyboard,
        "keyboard",
        HIDRD_USAGE_TYPE_CA),
    _PU(KEYPAD, keypad,
        "keypad",
        HIDRD_USAGE_TYPE_CA),
    _PU(MULTI_AXIS_CTRL, multi_axis_ctrl,
        "multi-axis controller",
        HIDRD_USAGE_TYPE_CA),
    _PU(TABLET_PC_SYSTEM, tablet_PC_system,
        "tablet PC system controls",
        HIDRD_USAGE_TYPE_CA),
    _PU(X, X,
        "X",
        HIDRD_USAGE_TYPE_DV),
    _PU(Y, Y,
        "Y",
        HIDRD_USAGE_TYPE_DV),
    _PU(Z, Z,
        "Z",
        HIDRD_USAGE_TYPE_DV),
    _PU(RX, Rx,
        "Rx",
        HIDRD_USAGE_TYPE_DV),
    _PU(RY, Ry,
        "Ry",
        HIDRD_USAGE_TYPE_DV),
    _PU(RZ, Rz,
        "Rz",
        HIDRD_USAGE_TYPE_DV),
    _PU(SLIDER, slider,
        "slider",
        HIDRD_USAGE_TYPE_DV),
    _PU(DIAL, dial,
        "dial",
        HIDRD_USAGE_TYPE_DV),
    _PU(WHEEL, wheel,
        "wheel",
        HIDRD_USAGE_TYPE_DV),
    _PU(HAT_SWITCH, hat_switch,
        "hat switch",
        HIDRD_USAGE_TYPE_DV),
    _PU(COUNTED_BUFFER, counted_buffer,
        "counted buffer",
        HIDRD_USAGE_TYPE_CL),
    _PU(BYTE_COUNT, byte_count,
        "byte count",
        HIDRD_USAGE_TYPE_DV),
    _PU(MOTION_WAKEUP, motion_wakeup,
        "motion wakeup",
        HIDRD_USAGE_TYPE_OSC),
    _PU(START, start,
        "start",
        HIDRD_USAGE_TYPE_OOC),
    _PU(SELECT, select,
        "select",
        HIDRD_USAGE_TYPE_OOC),
    _PU(VX, Vx,
        "Vx",
        HIDRD_USAGE_TYPE_DV),
    _PU(VY, Vy,
        "Vy",
        HIDRD_USAGE_TYPE_DV),
    _PU(VZ, Vz,
        "Vz",
        HIDRD_USAGE_TYPE_DV),
    _PU(VBRX, Vbrx,
        "Vbrx",
        HIDRD_USAGE_TYPE_DV),
    _PU(VBRY, Vbry,
        "Vbry",
        HIDRD_USAGE_TYPE_DV),
    _PU(VBRZ, Vbrz,
        "Vbrz",
        HIDRD_USAGE_TYPE_DV),
    _PU(VNO, Vno,
        "Vno",
        HIDRD_USAGE_TYPE_DV),
    _PU(FEATURE_NOTIFICATION, feature_notification,
        "feature notification",
        HIDRD_USAGE_TYPE_DV | HIDRD_USAGE_TYPE_DF),
    _PU(RESOLUTION_MULTIPLIER, resolution_multiplier,
        "resolution multiplier",
        HIDRD_USAGE_TYPE_DV),
    _PU(SYS_CONTROL, sys_control,
        "system control",
        HIDRD_USAGE_TYPE_CA),
    _PU(SYS_POWER_DOWN, sys_power_down,
        "system power down",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_SLEEP, sys_sleep,
        "system sleep",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_WAKE_UP, sys_wake_up,
        "system wake up",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_CONTEXT_MENU, sys_context_menu,
        "system context menu",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_MAIN_MENU, sys_main_menu,
        "system main menu",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_APP_MENU, sys_app_menu,
        "system app menu",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_MENU_HELP, sys_menu_help,
        "system menu help",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_MENU_EXIT, sys_menu_exit,
        "system menu exit",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_MENU_SELECT, sys_menu_select,
        "system menu select",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_MENU_RIGHT, sys_menu_right,
        "system menu right",
        HIDRD_USAGE_TYPE_RTC),
    _PU(SYS_MENU_LEFT, sys_menu_left,
        "system menu left",
        HIDRD_USAGE_TYPE_RTC),
    _PU(SYS_MENU_UP, sys_menu_up,
        "system menu up",
        HIDRD_USAGE_TYPE_RTC),
    _PU(SYS_MENU_DOWN, sys_menu_down,
        "system menu down",
        HIDRD_USAGE_TYPE_RTC),
    _PU(SYS_COLD_RESTART, sys_cold_restart,
        "system cold restart",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_WARM_RESTART, sys_warm_restart,
        "system warm restart",
        HIDRD_USAGE_TYPE_OSC),
    _PU(D_PAD_UP, D_pad_up,
        "D-pad up",
        HIDRD_USAGE_TYPE_OOC),
    _PU(D_PAD_DOWN, D_pad_down,
        "D-pad down",
        HIDRD_USAGE_TYPE_OOC),
    _PU(D_PAD_RIGHT, D_pad_right,
        "D-pad right",
        HIDRD_USAGE_TYPE_OOC),
    _PU(D_PAD_LEFT, D_pad_left,
        "D-pad left",
        HIDRD_USAGE_TYPE_OOC),
    _PU(SYS_DOCK, sys_dock,
        "system dock",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_UNDOCK, sys_undock,
        "system undock",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_SETUP, sys_setup,
        "system setup",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_BREAK, sys_break,
        "system break",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DBGR_BREAK, sys_dbgr_break,
        "system debugger break",
        HIDRD_USAGE_TYPE_OSC),
    _PU(APP_BREAK, app_break,
        "application break",
        HIDRD_USAGE_TYPE_OSC),
    _PU(APP_DBGR_BREAK, app_dbgr_break,
        "application debugger break",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_SPEAKER_MUTE, sys_speaker_mute,
        "system speaker mute",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_HIBERNATE, sys_hibernate,
        "system hibernate",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_INVERT, sys_dspl_invert,
        "system display invert",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_INTERNAL, sys_dspl_internal,
        "system display internal",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_EXTERNAL, sys_dspl_external,
        "system display external",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_BOTH, sys_dspl_both,
        "system display both",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_DUAL, sys_dspl_dual,
        "system display dual",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_TOGGLE_INT_EXT, sys_dspl_toggle_int_ext,
        "system display toggle int/ext",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_SWAP_1_2, sys_dspl_swap_1_2,
        "system display swap primary/secondary",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_LCD_AUTOSCALE, sys_dspl_LCD_autoscale,
        "system display LCD autoscale",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SYS_DSPL_ROT_LOCK_BTN, sys_dspl_rot_lock_btn,
        "system display rotation lock button",
        HIDRD_USAGE_TYPE_OOC),
    _PU(SYS_DSPL_ROT_LOCK_SLD, sys_dspl_rot_lock_sld,
        "system display rotation lock slider switch",
        HIDRD_USAGE_TYPE_OOC),

#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_simulation[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(SIMULATION_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_vr[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(VR_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_sport[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(SPORT_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_game[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(GAME_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_device[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(DEVICE_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_keyboard[219] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(KEYBOARD_##_TOKEN, _token, _name, _type_set)

    _PU(NONE, none,
        "no event",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_ERRORROLLOVER, KB_ErrorRollOver,
        "keyboard ErrorRollOver",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_POSTFAIL, KB_POSTFail,
        "keyboard POSTFail",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_ERRORUNDEFINED, KB_ErrorUndefined,
        "keyboard ErrorUndefined",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_A, KB_A,
        "keyboard a and A",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_B, KB_B,
        "keyboard b and B",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_C, KB_C,
        "keyboard c and C",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_D, KB_D,
        "keyboard d and D",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_E, KB_E,
        "keyboard e and E",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F, KB_F,
        "keyboard f and F",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_G, KB_G,
        "keyboard g and G",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_H, KB_H,
        "keyboard h and H",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_I, KB_I,
        "keyboard i and I",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_J, KB_J,
        "keyboard j and J",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_K, KB_K,
        "keyboard k and K",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_L, KB_L,
        "keyboard l and L",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_M, KB_M,
        "keyboard m and M",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_N, KB_N,
        "keyboard n and N",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_O, KB_O,
        "keyboard o and O",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_P, KB_P,
        "keyboard p and P",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_Q, KB_Q,
        "keyboard q and Q",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_R, KB_R,
        "keyboard r and R",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_S, KB_S,
        "keyboard s and S",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_T, KB_T,
        "keyboard t and T",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_U, KB_U,
        "keyboard u and U",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_V, KB_V,
        "keyboard v and V",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_W, KB_W,
        "keyboard w and W",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_X, KB_X,
        "keyboard x and X",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_Y, KB_Y,
        "keyboard y and Y",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_Z, KB_Z,
        "keyboard z and Z",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_1_AND_EXCLAM, KB_1_and_exclam,
        "keyboard 1 and !",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_2_AND_AT, KB_2_and_at,
        "keyboard 2 and @",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_3_AND_NUMBER, KB_3_and_number,
        "keyboard 3 and number",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_4_AND_DOLLAR, KB_4_and_dollar,
        "keyboard 4 and $",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_5_AND_PERCENT, KB_5_and_percent,
        "keyboard 5 and %",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_6_AND_CARET, KB_6_and_caret,
        "keyboard 6 and ^",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_7_AND_AMP, KB_7_and_amp,
        "keyboard 7 and &",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_8_AND_STAR, KB_8_and_star,
        "keyboard 8 and *",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_9_AND_LEFT_PAREN, KB_9_and_left_paren,
        "keyboard 9 and left parenthesis",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_0_AND_RIGHT_PAREN, KB_0_and_right_paren,
        "keyboard 0 and right parenthesis",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_ENTER, KB_Enter,
        "keyboard Return (ENTER)",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_ESCAPE, KB_Escape,
        "keyboard Escape",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_DELETE, KB_Delete,
        "keyboard Delete (Backspace)",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_TAB, KB_Tab,
        "keyboard Tab",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_SPACEBAR, KB_spacebar,
        "keyboard spacebar",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_MINUS_AND_UNDERSCORE, KB_minus_and_underscore,
        "keyboard - and _ (underscore)",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_EQUALS_AND_PLUS, KB_equals_and_plus,
        "keyboard = and +",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LBOXBRACKET_AND_LBRACE, KB_lboxbracket_and_lbrace,
        "keyboard [ and {",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_RBOXBRACKET_AND_RBRACE, KB_rboxbracket_and_rbrace,
        "keyboard ] and }",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_BACKSLASH_AND_PIPE, KB_backslash_and_pipe,
        "keyboard backslash and |",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_NON_US_NUMBER_AND_TILDE, KB_non_US_number_and_tilde,
        "keyboard non-US number and ~",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_SEMICOLON_AND_COLON, KB_semicolon_and_colon,
        "keyboard ; and :",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_QUOT_AND_DBLQUOT, KB_quot_and_dblquot,
        "keyboard ‘ and “",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_GRAVE_ACCENT_AND_TILDE, KB_grave_accent_and_tilde,
        "keyboard grave accent and tilde",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_COMMA_AND_LT, KB_comma_and_lt,
        "keyboard , and <",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_PERIOD_AND_GT, KB_period_and_gt,
        "keyboard . and >",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_SLASH_AND_QUESTION, KB_slash_and_question,
        "keyboard / and ?",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_CAPS_LOCK, KB_Caps_Lock,
        "keyboard Caps Lock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F1, KB_F1,
        "keyboard F1",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F2, KB_F2,
        "keyboard F2",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F3, KB_F3,
        "keyboard F3",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F4, KB_F4,
        "keyboard F4",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F5, KB_F5,
        "keyboard F5",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F6, KB_F6,
        "keyboard F6",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F7, KB_F7,
        "keyboard F7",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F8, KB_F8,
        "keyboard F8",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F9, KB_F9,
        "keyboard F9",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F10, KB_F10,
        "keyboard F10",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F11, KB_F11,
        "keyboard F11",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F12, KB_F12,
        "keyboard F12",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_PRINT_SCREEN, KB_Print_Screen,
        "keyboard Print Screen",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_SCROLL_LOCK, KB_Scroll_Lock,
        "keyboard Scroll Lock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_PAUSE, KB_Pause,
        "keyboard Pause",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INSERT, KB_Insert,
        "keyboard Insert",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_HOME, KB_Home,
        "keyboard Home",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_PAGEUP, KB_PageUp,
        "keyboard PageUp",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_DELETE_FORWARD, KB_Delete_Forward,
        "keyboard Delete Forward",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_END, KB_End,
        "keyboard End",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_PAGEDOWN, KB_PageDown,
        "keyboard PageDown",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_RIGHTARROW, KB_RightArrow,
        "keyboard RightArrow",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LEFTARROW, KB_LeftArrow,
        "keyboard LeftArrow",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_DOWNARROW, KB_DownArrow,
        "keyboard DownArrow",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_UPARROW, KB_UpArrow,
        "keyboard UpArrow",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_NUM_LOCK_AND_CLEAR, KP_Num_Lock_and_Clear,
        "keypad Num Lock and Clear",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_SLASH, KP_slash,
        "keypad /",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_STAR, KP_star,
        "keypad *",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_MINUS, KP_minus,
        "keypad -",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_PLUS, KP_plus,
        "keypad +",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_ENTER, KP_enter,
        "keypad Enter",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_1_AND_END, KP_1_and_End,
        "keypad 1 and End",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_2_AND_DOWNARROW, KP_2_and_DownArrow,
        "keypad 2 and Down Arrow",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_3_AND_PAGEDN, KP_3_and_PageDn,
        "keypad 3 and PageDn",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_4_AND_LEFTARROW, KP_4_and_LeftArrow,
        "keypad 4 and Left Arrow",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_5, KP_5,
        "keypad 5",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_6_AND_RIGHTARROW, KP_6_and_RightArrow,
        "keypad 6 and Right Arrow",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_7_AND_HOME, KP_7_and_Home,
        "keypad 7 and Home",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_8_AND_UPARROW, KP_8_and_UpArrow,
        "keypad 8 and Up Arrow",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_9_AND_PAGEUP, KP_9_and_PageUp,
        "keypad 9 and PageUp",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_0_AND_INSERT, KP_0_and_Insert,
        "keypad 0 and Insert",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_PERIOD_AND_DELETE, KP_period_and_Delete,
        "keypad . and Delete",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_NON_US_BACKSLASH_AND_PIPE, KB_non_US_backslash_and_pipe,
        "keyboard non-US backslash and |",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_APPLICATION, KB_Application,
        "keyboard Application",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_POWER, KB_Power,
        "keyboard Power",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_EQUALS, KP_equals,
        "keypad =",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F13, KB_F13,
        "keyboard F13",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F14, KB_F14,
        "keyboard F14",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F15, KB_F15,
        "keyboard F15",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F16, KB_F16,
        "keyboard F16",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F17, KB_F17,
        "keyboard F17",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F18, KB_F18,
        "keyboard F18",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F19, KB_F19,
        "keyboard F19",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F20, KB_F20,
        "keyboard F20",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F21, KB_F21,
        "keyboard F21",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F22, KB_F22,
        "keyboard F22",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F23, KB_F23,
        "keyboard F23",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_F24, KB_F24,
        "keyboard F24",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_EXECUTE, KB_Execute,
        "keyboard Execute",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_HELP, KB_Help,
        "keyboard Help",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_MENU, KB_Menu,
        "keyboard Menu",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_SELECT, KB_Select,
        "keyboard Select",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_STOP, KB_Stop,
        "keyboard Stop",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_AGAIN, KB_Again,
        "keyboard Again",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_UNDO, KB_Undo,
        "keyboard Undo",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_CUT, KB_Cut,
        "keyboard Cut",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_COPY, KB_Copy,
        "keyboard Copy",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_PASTE, KB_Paste,
        "keyboard Paste",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_FIND, KB_Find,
        "keyboard Find",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_MUTE, KB_Mute,
        "keyboard Mute",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_VOLUME_UP, KB_Volume_Up,
        "keyboard Volume Up",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_VOLUME_DOWN, KB_Volume_Down,
        "keyboard Volume Down",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LOCKING_CAPS_LOCK, KB_locking_Caps_Lock,
        "keyboard locking Caps Lock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LOCKING_NUM_LOCK, KB_locking_Num_Lock,
        "keyboard locking Num Lock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LOCKING_SCROLL_LOCK, KB_locking_Scroll_Lock,
        "keyboard locking Scroll Lock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_COMMA, KP_comma,
        "keypad comma",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_EQUALS_AS_400, KP_equals_AS_400,
        "keypad = (AS/400)",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL1, KB_Intl1,
        "keyboard International1",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL2, KB_Intl2,
        "keyboard International2",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL3, KB_Intl3,
        "keyboard International3",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL4, KB_Intl4,
        "keyboard International4",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL5, KB_Intl5,
        "keyboard International5",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL6, KB_Intl6,
        "keyboard International6",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL7, KB_Intl7,
        "keyboard International7",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL8, KB_Intl8,
        "keyboard International8",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_INTL9, KB_Intl9,
        "keyboard International9",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG1, KB_LANG1,
        "keyboard LANG1",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG2, KB_LANG2,
        "keyboard LANG2",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG3, KB_LANG3,
        "keyboard LANG3",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG4, KB_LANG4,
        "keyboard LANG4",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG5, KB_LANG5,
        "keyboard LANG5",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG6, KB_LANG6,
        "keyboard LANG6",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG7, KB_LANG7,
        "keyboard LANG7",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG8, KB_LANG8,
        "keyboard LANG8",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LANG9, KB_LANG9,
        "keyboard LANG9",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_ALTERNATE_ERASE, KB_Alternate_Erase,
        "keyboard Alternate Erase",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_SYSREQ_OR_ATTENTION, KB_SysReq_or_Attention,
        "keyboard SysReq/Attention",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_CANCEL, KB_Cancel,
        "keyboard Cancel",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_CLEAR, KB_Clear,
        "keyboard Clear",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_PRIOR, KB_Prior,
        "keyboard Prior",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_RETURN, KB_Return,
        "keyboard Return",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_SEPARATOR, KB_Separator,
        "keyboard Separator",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_OUT, KB_Out,
        "keyboard Out",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_OPER, KB_Oper,
        "keyboard Oper",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_CLEAR_OR_AGAIN, KB_Clear_or_Again,
        "keyboard Clear/Again",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_CRSEL_OR_PROPS, KB_Crsel_or_Props,
        "keyboard CrSel/Props",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_EXSEL, KB_ExSel,
        "keyboard ExSel",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_00, KP_00,
        "keypad 00",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_000, KP_000,
        "keypad 000",
        HIDRD_USAGE_TYPE_SEL),
    _PU(THOUSANDS_SEPARATOR, thousands_separator,
        "thousands separator",
        HIDRD_USAGE_TYPE_SEL),
    _PU(DECIMAL_SEPARATOR, decimal_separator,
        "decimal separator",
        HIDRD_USAGE_TYPE_SEL),
    _PU(CURRENCY_UNIT, currency_unit,
        "currency unit",
        HIDRD_USAGE_TYPE_SEL),
    _PU(CURRENCY_SUBUNIT, currency_subunit,
        "currency sub-unit",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_LEFT_PAREN, KP_left_paren,
        "keypad left parenthesis",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_RIGHT_PAREN, KP_right_paren,
        "keypad right parenthesis",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_LEFT_BRACE, KP_left_brace,
        "keypad {",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_RIGHT_BRACE, KP_right_brace,
        "keypad }",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_TAB, KP_Tab,
        "keypad Tab",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_BACKSPACE, KP_Backspace,
        "keypad Backspace",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_A, KP_A,
        "keypad A",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_B, KP_B,
        "keypad B",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_C, KP_C,
        "keypad C",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_D, KP_D,
        "keypad D",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_E, KP_E,
        "keypad E",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_F, KP_F,
        "keypad F",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_XOR, KP_XOR,
        "keypad XOR",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_CARET, KP_caret,
        "keypad ^",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_PERCENT, KP_percent,
        "keypad %",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_LT, KP_lt,
        "keypad <",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_GT, KP_gt,
        "keypad >",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_AMP, KP_amp,
        "keypad &",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_DBLAMP, KP_dblamp,
        "keypad &&",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_PIPE, KP_pipe,
        "keypad |",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_DBLPIPE, KP_dblpipe,
        "keypad ||",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_COLON, KP_colon,
        "keypad :",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_NUMBER, KP_number,
        "keypad number",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_SPACE, KP_Space,
        "keypad Space",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_AT, KP_at,
        "keypad @",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_EXCLAMATION, KP_exclamation,
        "keypad !",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_MEM_STORE, KP_Mem_Store,
        "keypad Memory Store",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_MEM_RECALL, KP_Mem_Recall,
        "keypad Memory Recall",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_MEM_CLEAR, KP_Mem_Clear,
        "keypad Memory Clear",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_MEM_ADD, KP_Mem_Add,
        "keypad Memory Add",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_MEM_SUBTRACT, KP_Mem_Subtract,
        "keypad Memory Subtract",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_MEM_MULTIPLY, KP_Mem_Multiply,
        "keypad Memory Multiply",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_MEM_DIVIDE, KP_Mem_Divide,
        "keypad Memory Divide",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_PLUS_MINUS, KP_plus_minus,
        "keypad +/-",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_CLEAR, KP_Clear,
        "keypad Clear",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_CLEAR_ENTRY, KP_Clear_Entry,
        "keypad Clear Entry",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_BINARY, KP_Binary,
        "keypad Binary",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_OCTAL, KP_Octal,
        "keypad Octal",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_DECIMAL, KP_Decimal,
        "keypad Decimal",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KP_HEXADECIMAL, KP_Hexadecimal,
        "keypad Hexadecimal",
        HIDRD_USAGE_TYPE_SEL),
    _PU(KB_LEFTCONTROL, KB_leftcontrol,
        "keyboard left control",
        HIDRD_USAGE_TYPE_DV),
    _PU(KB_LEFTSHIFT, KB_leftshift,
        "keyboard left shift",
        HIDRD_USAGE_TYPE_DV),
    _PU(KB_LEFTALT, KB_leftalt,
        "keyboard left alt",
        HIDRD_USAGE_TYPE_DV),
    _PU(KB_LEFT_GUI, KB_left_GUI,
        "keyboard left GUI",
        HIDRD_USAGE_TYPE_DV),
    _PU(KB_RIGHTCONTROL, KB_rightcontrol,
        "keyboard right control",
        HIDRD_USAGE_TYPE_DV),
    _PU(KB_RIGHTSHIFT, KB_rightshift,
        "keyboard right shift",
        HIDRD_USAGE_TYPE_DV),
    _PU(KB_RIGHTALT, KB_rightalt,
        "keyboard right alt",
        HIDRD_USAGE_TYPE_DV),
    _PU(KB_RIGHT_GUI, KB_right_GUI,
        "keyboard right GUI",
        HIDRD_USAGE_TYPE_DV),

#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_led[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(LED_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_button[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(BUTTON_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_ordinal[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(ORDINAL_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_telephony[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(TELEPHONY_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_consumer[364] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(CONSUMER_##_TOKEN, _token, _name, _type_set)

    _PU(CONSUMER_CONTROL, consumer_control,
        "consumer control",
        HIDRD_USAGE_TYPE_CA),
    _PU(NUMERIC_KEYPAD, numeric_keypad,
        "numeric key pad",
        HIDRD_USAGE_TYPE_NARY),
    _PU(PROGRAMMABLE_BUTTONS, programmable_buttons,
        "programmable buttons",
        HIDRD_USAGE_TYPE_NARY),
    _PU(MICROPHONE, microphone,
        "microphone",
        HIDRD_USAGE_TYPE_CA),
    _PU(HEADPHONE, headphone,
        "headphone",
        HIDRD_USAGE_TYPE_CA),
    _PU(GRAPHIC_EQUALIZER, graphic_equalizer,
        "graphic equalizer",
        HIDRD_USAGE_TYPE_CA),
    _PU(PLUS_10, plus_10,
        "+10",
        HIDRD_USAGE_TYPE_OSC),
    _PU(PLUS_100, plus_100,
        "+100",
        HIDRD_USAGE_TYPE_OSC),
    _PU(AM_PM, AM_PM,
        "AM/PM",
        HIDRD_USAGE_TYPE_OSC),
    _PU(POWER, power,
        "power",
        HIDRD_USAGE_TYPE_OOC),
    _PU(RESET, reset,
        "reset",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SLEEP, sleep,
        "sleep",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SLEEP_AFTER, sleep_after,
        "sleep after",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SLEEP_MODE, sleep_mode,
        "sleep mode",
        HIDRD_USAGE_TYPE_RTC),
    _PU(ILLUMINATION, illumination,
        "illumination",
        HIDRD_USAGE_TYPE_OOC),
    _PU(FUNCTION_BUTTONS, function_buttons,
        "function buttons",
        HIDRD_USAGE_TYPE_NARY),
    _PU(MENU, menu,
        "menu",
        HIDRD_USAGE_TYPE_OOC),
    _PU(MENU_PICK, menu_pick,
        "menu pick",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MENU_UP, menu_up,
        "menu up",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MENU_DOWN, menu_down,
        "menu down",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MENU_LEFT, menu_left,
        "menu left",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MENU_RIGHT, menu_right,
        "menu right",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MENU_ESCAPE, menu_escape,
        "menu escape",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MENU_VALUE_INC, menu_value_inc,
        "menu value increase",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MENU_VALUE_DEC, menu_value_dec,
        "menu value decrease",
        HIDRD_USAGE_TYPE_OSC),
    _PU(DATA_ON_SCREEN, data_on_screen,
        "data on screen",
        HIDRD_USAGE_TYPE_OOC),
    _PU(CLOSED_CAPTION, closed_caption,
        "closed caption",
        HIDRD_USAGE_TYPE_OOC),
    _PU(CLOSED_CAPTION_SELECT, closed_caption_select,
        "closed caption select",
        HIDRD_USAGE_TYPE_OSC),
    _PU(VCR_TV, VCR_TV,
        "VCR/TV",
        HIDRD_USAGE_TYPE_OOC),
    _PU(BROADCAST_MODE, broadcast_mode,
        "broadcast mode",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SNAPSHOT, snapshot,
        "snapshot",
        HIDRD_USAGE_TYPE_OSC),
    _PU(STILL, still,
        "still",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SELECTION, selection,
        "selection",
        HIDRD_USAGE_TYPE_NARY),
    _PU(ASSIGN_SELECTION, assign_selection,
        "assign selection",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MODE_STEP, mode_step,
        "mode step",
        HIDRD_USAGE_TYPE_OSC),
    _PU(RECALL_LAST, recall_last,
        "recall last",
        HIDRD_USAGE_TYPE_OSC),
    _PU(ENTER_CHANNEL, enter_channel,
        "enter channel",
        HIDRD_USAGE_TYPE_OSC),
    _PU(ORDER_MOVIE, order_movie,
        "order movie",
        HIDRD_USAGE_TYPE_OSC),
    _PU(CHANNEL, channel,
        "channel",
        HIDRD_USAGE_TYPE_LC),
    _PU(MEDIA_SELECTION, media_selection,
        "media selection",
        HIDRD_USAGE_TYPE_NARY),
    _PU(MEDIA_SELECT_COMPUTER, media_select_computer,
        "media select computer",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_TV, media_select_TV,
        "media select TV",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_WWW, media_select_WWW,
        "media select WWW",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_DVD, media_select_DVD,
        "media select DVD",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_TELEPHONE, media_select_telephone,
        "media select telephone",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_PROGRAM_GUIDE, media_select_program_guide,
        "media select program guide",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_VIDEO_PHONE, media_select_video_phone,
        "media select video phone",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_GAMES, media_select_games,
        "media select games",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_MESSAGES, media_select_messages,
        "media select messages",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_CD, media_select_CD,
        "media select CD",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_VCR, media_select_VCR,
        "media select VCR",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_TUNER, media_select_tuner,
        "media select tuner",
        HIDRD_USAGE_TYPE_SEL),
    _PU(QUIT, quit,
        "quit",
        HIDRD_USAGE_TYPE_OSC),
    _PU(HELP, help,
        "help",
        HIDRD_USAGE_TYPE_OOC),
    _PU(MEDIA_SELECT_TAPE, media_select_tape,
        "media select tape",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_CABLE, media_select_cable,
        "media select cable",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_SATELLITE, media_select_satellite,
        "media select satellite",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_SECURITY, media_select_security,
        "media select security",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_HOME, media_select_home,
        "media select home",
        HIDRD_USAGE_TYPE_SEL),
    _PU(MEDIA_SELECT_CALL, media_select_call,
        "media select call",
        HIDRD_USAGE_TYPE_SEL),
    _PU(CHANNEL_INC, channel_inc,
        "channel increment",
        HIDRD_USAGE_TYPE_OSC),
    _PU(CHANNEL_DEC, channel_dec,
        "channel decrement",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MEDIA_SELECT_SAP, media_select_SAP,
        "media select SAP",
        HIDRD_USAGE_TYPE_SEL),
    _PU(VCR_PLUS, VCR_plus,
        "VCR plus",
        HIDRD_USAGE_TYPE_OSC),
    _PU(ONCE, once,
        "once",
        HIDRD_USAGE_TYPE_OSC),
    _PU(DAILY, daily,
        "daily",
        HIDRD_USAGE_TYPE_OSC),
    _PU(WEEKLY, weekly,
        "weekly",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MONTHLY, monthly,
        "monthly",
        HIDRD_USAGE_TYPE_OSC),
    _PU(PLAY, play,
        "play",
        HIDRD_USAGE_TYPE_OOC),
    _PU(PAUSE, pause,
        "pause",
        HIDRD_USAGE_TYPE_OOC),
    _PU(RECORD, record,
        "record",
        HIDRD_USAGE_TYPE_OOC),
    _PU(FAST_FORWARD, fast_forward,
        "fast forward",
        HIDRD_USAGE_TYPE_OOC),
    _PU(REWIND, rewind,
        "rewind",
        HIDRD_USAGE_TYPE_OOC),
    _PU(SCAN_NEXT_TRACK, scan_next_track,
        "scan next track",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SCAN_PREVIOUS_TRACK, scan_previous_track,
        "scan previous track",
        HIDRD_USAGE_TYPE_OSC),
    _PU(STOP, stop,
        "stop",
        HIDRD_USAGE_TYPE_OSC),
    _PU(EJECT, eject,
        "eject",
        HIDRD_USAGE_TYPE_OSC),
    _PU(RANDOM_PLAY, random_play,
        "random play",
        HIDRD_USAGE_TYPE_OOC),
    _PU(SELECT_DISC, select_disc,
        "select disc",
        HIDRD_USAGE_TYPE_NARY),
    _PU(ENTER_DISC, enter_disc,
        "enter disc",
        HIDRD_USAGE_TYPE_MC),
    _PU(REPEAT, repeat,
        "repeat",
        HIDRD_USAGE_TYPE_OSC),
    _PU(TRACKING, tracking,
        "tracking",
        HIDRD_USAGE_TYPE_LC),
    _PU(TRACK_NORMAL, track_normal,
        "track normal",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SLOW_TRACKING, slow_tracking,
        "slow tracking",
        HIDRD_USAGE_TYPE_LC),
    _PU(FRAME_FORWARD, frame_forward,
        "frame forward",
        HIDRD_USAGE_TYPE_RTC),
    _PU(FRAME_BACK, frame_back,
        "frame back",
        HIDRD_USAGE_TYPE_RTC),
    _PU(MARK, mark,
        "mark",
        HIDRD_USAGE_TYPE_OSC),
    _PU(CLEAR_MARK, clear_mark,
        "clear mark",
        HIDRD_USAGE_TYPE_OSC),
    _PU(REPEAT_FROM_MARK, repeat_from_mark,
        "repeat from mark",
        HIDRD_USAGE_TYPE_OOC),
    _PU(RETURN_TO_MARK, return_to_mark,
        "return to mark",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SEARCH_MARK_FORWARD, search_mark_forward,
        "search mark forward",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SEARCH_MARK_BACKWARDS, search_mark_backwards,
        "search mark backwards",
        HIDRD_USAGE_TYPE_OSC),
    _PU(COUNTER_RESET, counter_reset,
        "Counter Reset",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SHOW_COUNTER, show_counter,
        "show counter",
        HIDRD_USAGE_TYPE_OSC),
    _PU(TRACKING_INC, tracking_inc,
        "tracking increment",
        HIDRD_USAGE_TYPE_RTC),
    _PU(TRACKING_DEC, tracking_dec,
        "tracking decrement",
        HIDRD_USAGE_TYPE_RTC),
    _PU(STOP_EJECT, stop_eject,
        "stop/eject",
        HIDRD_USAGE_TYPE_OSC),
    _PU(PLAY_PAUSE, play_pause,
        "play/pause",
        HIDRD_USAGE_TYPE_OSC),
    _PU(PLAY_SKIP, play_skip,
        "play/skip",
        HIDRD_USAGE_TYPE_OSC),
    _PU(VOLUME, volume,
        "volume",
        HIDRD_USAGE_TYPE_LC),
    _PU(BALANCE, balance,
        "balance",
        HIDRD_USAGE_TYPE_LC),
    _PU(MUTE, mute,
        "mute",
        HIDRD_USAGE_TYPE_OOC),
    _PU(BASS, bass,
        "bass",
        HIDRD_USAGE_TYPE_LC),
    _PU(TREBLE, treble,
        "treble",
        HIDRD_USAGE_TYPE_LC),
    _PU(BASS_BOOST, bass_boost,
        "bass boost",
        HIDRD_USAGE_TYPE_OOC),
    _PU(SURROUND_MODE, surround_mode,
        "surround mode",
        HIDRD_USAGE_TYPE_OSC),
    _PU(LOUDNESS, loudness,
        "loudness",
        HIDRD_USAGE_TYPE_OOC),
    _PU(MPX, MPX,
        "MPX",
        HIDRD_USAGE_TYPE_OOC),
    _PU(VOLUME_INC, volume_inc,
        "volume increment",
        HIDRD_USAGE_TYPE_RTC),
    _PU(VOLUME_DEC, volume_dec,
        "volume decrement",
        HIDRD_USAGE_TYPE_RTC),
    _PU(SPEED_SELECT, speed_select,
        "speed select",
        HIDRD_USAGE_TYPE_OSC),
    _PU(PLAYBACK_SPEED, playback_speed,
        "playback speed",
        HIDRD_USAGE_TYPE_NARY),
    _PU(STANDARD_PLAY, standard_play,
        "standard play",
        HIDRD_USAGE_TYPE_SEL),
    _PU(LONG_PLAY, long_play,
        "long play",
        HIDRD_USAGE_TYPE_SEL),
    _PU(EXTENDED_PLAY, extended_play,
        "extended play",
        HIDRD_USAGE_TYPE_SEL),
    _PU(SLOW, slow,
        "slow",
        HIDRD_USAGE_TYPE_OSC),
    _PU(FAN_ENABLE, fan_enable,
        "fan enable",
        HIDRD_USAGE_TYPE_OOC),
    _PU(FAN_SPEED, fan_speed,
        "fan speed",
        HIDRD_USAGE_TYPE_LC),
    _PU(LIGHT_ENABLE, light_enable,
        "light enable",
        HIDRD_USAGE_TYPE_OOC),
    _PU(LIGHT_ILLUMINATION_LEVEL, light_illumination_level,
        "light illumination level",
        HIDRD_USAGE_TYPE_LC),
    _PU(CLIMATE_CONTROL_ENABLE, climate_control_enable,
        "climate control enable",
        HIDRD_USAGE_TYPE_OOC),
    _PU(ROOM_TEMPERATURE, room_temperature,
        "room temperature",
        HIDRD_USAGE_TYPE_LC),
    _PU(SECURITY_ENABLE, security_enable,
        "security enable",
        HIDRD_USAGE_TYPE_OOC),
    _PU(FIRE_ALARM, fire_alarm,
        "fire alarm",
        HIDRD_USAGE_TYPE_OSC),
    _PU(POLICE_ALARM, police_alarm,
        "police alarm",
        HIDRD_USAGE_TYPE_OSC),
    _PU(PROXIMITY, proximity,
        "proximity",
        HIDRD_USAGE_TYPE_LC),
    _PU(MOTION, motion,
        "motion",
        HIDRD_USAGE_TYPE_OSC),
    _PU(DURESS_ALARM, duress_alarm,
        "duress alarm",
        HIDRD_USAGE_TYPE_OSC),
    _PU(HOLDUP_ALARM, holdup_alarm,
        "holdup alarm",
        HIDRD_USAGE_TYPE_OSC),
    _PU(MEDICAL_ALARM, medical_alarm,
        "medical alarm",
        HIDRD_USAGE_TYPE_OSC),
    _PU(BALANCE_RIGHT, balance_right,
        "balance right",
        HIDRD_USAGE_TYPE_RTC),
    _PU(BALANCE_LEFT, balance_left,
        "balance left",
        HIDRD_USAGE_TYPE_RTC),
    _PU(BASS_INC, bass_inc,
        "bass increment",
        HIDRD_USAGE_TYPE_RTC),
    _PU(BASS_DEC, bass_dec,
        "bass decrement",
        HIDRD_USAGE_TYPE_RTC),
    _PU(TREBLE_INC, treble_inc,
        "treble increment",
        HIDRD_USAGE_TYPE_RTC),
    _PU(TREBLE_DEC, treble_dec,
        "treble decrement",
        HIDRD_USAGE_TYPE_RTC),
    _PU(SPEAKER_SYSTEM, speaker_system,
        "speaker system",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_LEFT, channel_left,
        "channel left",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_RIGHT, channel_right,
        "channel right",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_CENTER, channel_center,
        "channel center",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_FRONT, channel_front,
        "channel front",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_CENTER_FRONT, channel_center_front,
        "channel center front",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_SIDE, channel_side,
        "channel side",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_SURROUND, channel_surround,
        "channel surround",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_LOW_FREQ_ENHAN, channel_low_freq_enhan,
        "channel low frequency enhancement",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_TOP, channel_top,
        "channel top",
        HIDRD_USAGE_TYPE_CL),
    _PU(CHANNEL_UNKNOWN, channel_unknown,
        "channel unknown",
        HIDRD_USAGE_TYPE_CL),
    _PU(SUBCHANNEL, subchannel,
        "sub-channel",
        HIDRD_USAGE_TYPE_LC),
    _PU(SUBCHANNEL_INC, subchannel_inc,
        "sub-channel increment",
        HIDRD_USAGE_TYPE_OSC),
    _PU(SUBCHANNEL_DEC, subchannel_dec,
        "sub-channel decrement",
        HIDRD_USAGE_TYPE_OSC),
    _PU(ALTERNATE_AUDIO_INC, alternate_audio_inc,
        "alternate audio increment",
        HIDRD_USAGE_TYPE_OSC),
    _PU(ALTERNATE_AUDIO_DEC, alternate_audio_dec,
        "alternate audio decrement",
        HIDRD_USAGE_TYPE_OSC),
    _PU(APP_LAUNCH_BUTTONS, app_launch_buttons,
        "application launch buttons",
        HIDRD_USAGE_TYPE_NARY),
    _PU(AL_LAUNCH_BUTTON_CONFIG_TOOL, AL_launch_button_config_tool,
        "AL launch button configuration tool",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_PROGRAMMABLE_BUTTON_CONFIG, AL_programmable_button_config,
        "AL programmable button configuration",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CONSUMER_CONTROL_CONFIG, AL_consumer_control_config,
        "AL consumer control configuration",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_WORD_PROC, AL_word_proc,
        "AL word processor",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_TEXT_EDITOR, AL_text_editor,
        "AL text editor",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_SPREADSHEET, AL_spreadsheet,
        "AL spreadsheet",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_GRAPHICS_EDITOR, AL_graphics_editor,
        "AL graphics editor",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_PRESENTATION_APP, AL_presentation_app,
        "AL presentation app",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_DATABASE_APP, AL_database_app,
        "AL database app",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_EMAIL_READER, AL_email_reader,
        "AL email reader",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_NEWSREADER, AL_newsreader,
        "AL newsreader",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_VOICEMAIL, AL_voicemail,
        "AL voicemail",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CONTACTS_OR_ADDRESS_BOOK, AL_contacts_or_address_book,
        "AL contacts/address book",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CALENDAR_OR_SCHEDULE, AL_calendar_or_schedule,
        "AL calendar/schedule",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_TASK_OR_PROJECT_MNGR, AL_task_or_project_mngr,
        "AL task/project manager",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_LOG_OR_JOURNAL_OR_TIMECARD, AL_log_or_journal_or_timecard,
        "AL log/journal/timecard",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CHECKBOOK_OR_FINANCE, AL_checkbook_or_finance,
        "AL checkbook/finance",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CALCULATOR, AL_calculator,
        "AL calculator",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_AV_CAPTURE_OR_PLAYBACK, AL_AV_capture_or_playback,
        "AL A/V capture/playback",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_LOCAL_MACHINE_BRWSR, AL_local_machine_brwsr,
        "AL local machine browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_LAN_OR_WAN_BRWSR, AL_LAN_or_WAN_brwsr,
        "AL LAN/WAN browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_INTERNET_BRWSR, AL_internet_brwsr,
        "AL Internet browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_REMOTE_NET_OR_ISP_CONNECT, AL_remote_net_or_ISP_connect,
        "AL remote networking/ISP connect",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_NETWORK_CONFERENCE, AL_network_conference,
        "AL network conference",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_NETWORK_CHAT, AL_network_chat,
        "AL network chat",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_TELEPHONY_OR_DIALER, AL_telephony_or_dialer,
        "AL telephony/dialer",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_LOGON, AL_logon,
        "AL logon",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_LOGOFF, AL_logoff,
        "AL logoff",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_LOGON_OR_LOGOFF, AL_logon_or_logoff,
        "AL logon/logoff",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_TERM_LOCK_OR_SCREENSAVER, AL_term_lock_or_screensaver,
        "AL terminal lock/screensaver",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CONTROL_PANEL, AL_control_panel,
        "AL control panel",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CMD_LINE_PROC_OR_RUN, AL_cmd_line_proc_or_run,
        "AL command line processor/run",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_PROC_OR_TASK_MNGR, AL_proc_or_task_mngr,
        "AL process/task manager",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_SELECT_TASK_OR_APP, AL_select_task_or_app,
        "AL select task/application",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_NEXT_TASK_OR_APP, AL_next_task_or_app,
        "AL next task/application",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_PREVIOUS_TASK_OR_APP, AL_previous_task_or_app,
        "AL previous task/application",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_PREEMPTIVE_HALT_TASK_OR_APP, AL_preemptive_halt_task_or_app,
        "AL preemptive halt task/application",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_INTEGRATED_HELP_CENTER, AL_integrated_help_center,
        "AL integrated help center",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_DOCUMENTS, AL_documents,
        "AL documents",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_THESAURUS, AL_thesaurus,
        "AL thesaurus",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_DICTIONARY, AL_dictionary,
        "AL dictionary",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_DESKTOP, AL_desktop,
        "AL desktop",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_SPELL_CHECK, AL_spell_check,
        "AL spell check",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_GRAMMAR_CHECK, AL_grammar_check,
        "AL grammar check",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_WIRELESS_STATUS, AL_wireless_status,
        "AL wireless status",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_KEYBOARD_LAYOUT, AL_keyboard_layout,
        "AL keyboard layout",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_VIRUS_PROTECTION, AL_virus_protection,
        "AL virus protection",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_ENCRYPTION, AL_encryption,
        "AL encryption",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_SCREEN_SAVER, AL_screen_saver,
        "AL screen saver",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_ALARMS, AL_alarms,
        "AL alarms",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CLOCK, AL_clock,
        "AL clock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_FILE_BRWSR, AL_file_brwsr,
        "AL file browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_POWER_STATUS, AL_power_status,
        "AL power status",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_IMAGE_BRWSR, AL_image_brwsr,
        "AL image browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_AUDIO_BRWSR, AL_audio_brwsr,
        "AL audio browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_MOVIE_BRWSR, AL_movie_brwsr,
        "AL movie browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_DIGITAL_RIGHTS_MNGR, AL_digital_rights_mngr,
        "AL digital rights manager",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_DIGITAL_WALLET, AL_digital_wallet,
        "AL digital wallet",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_INSTANT_MESSAGING, AL_instant_messaging,
        "AL instant messaging",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_OEM_FEATS_BRWSR, AL_OEM_feats_brwsr,
        "AL OEM features/tips/tutorial browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_OEM_HELP, AL_OEM_help,
        "AL OEM help",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_ONLINE_COMMUNITY, AL_online_community,
        "AL online community",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_ENT_CONTENT_BRWSR, AL_ent_content_brwsr,
        "AL entertainment content browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_ONLINE_SHOPPING_BRWSR, AL_online_shopping_brwsr,
        "AL online shopping browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_SMARTCARD_INFO_OR_HELP, AL_smartcard_info_or_help,
        "AL smartcard information/help",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_MRKT_MON_OR_FIN_BRWSR, AL_mrkt_mon_or_fin_brwsr,
        "AL market monitor/finance browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_CUSTOM_CORP_NEWS_BRWSR, AL_custom_corp_news_brwsr,
        "AL customized corporate news browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_ONLINE_ACTIVITY_BRWSR, AL_online_activity_brwsr,
        "AL online activity browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_RESEARCH_OR_SEARCH_BRWSR, AL_research_or_search_brwsr,
        "AL research/search browser",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AL_AUDIO_PLAYER, AL_audio_player,
        "AL audio player",
        HIDRD_USAGE_TYPE_SEL),
    _PU(GENERIC_GUI_APP_CONTROLS, generic_GUI_app_controls,
        "generic GUI application controls",
        HIDRD_USAGE_TYPE_NARY),
    _PU(AC_NEW, AC_new,
        "AC new",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_OPEN, AC_open,
        "AC open",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_CLOSE, AC_close,
        "AC close",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_EXIT, AC_exit,
        "AC exit",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_MAXIMIZE, AC_maximize,
        "AC maximize",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_MINIMIZE, AC_minimize,
        "AC minimize",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SAVE, AC_save,
        "AC save",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PRINT, AC_print,
        "AC print",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PROPERTIES, AC_properties,
        "AC properties",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_UNDO, AC_undo,
        "AC undo",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_COPY, AC_copy,
        "AC copy",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_CUT, AC_cut,
        "AC cut",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PASTE, AC_paste,
        "AC paste",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_ALL, AC_select_all,
        "AC select all",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FIND, AC_find,
        "AC find",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FIND_AND_REPLACE, AC_find_and_replace,
        "AC find and replace",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SEARCH, AC_search,
        "AC search",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_GO_TO, AC_go_to,
        "AC go to",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_HOME, AC_home,
        "AC home",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_BACK, AC_back,
        "AC back",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FORWARD, AC_forward,
        "AC forward",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_STOP, AC_stop,
        "AC stop",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_REFRESH, AC_refresh,
        "AC refresh",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PREVIOUS_LINK, AC_previous_link,
        "AC previous link",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_NEXT_LINK, AC_next_link,
        "AC next link",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_BOOKMARKS, AC_bookmarks,
        "AC bookmarks",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_HISTORY, AC_history,
        "AC history",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SUBSCRIPTIONS, AC_subscriptions,
        "AC subscriptions",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ZOOM_IN, AC_zoom_in,
        "AC zoom in",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ZOOM_OUT, AC_zoom_out,
        "AC zoom out",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ZOOM, AC_zoom,
        "AC zoom",
        HIDRD_USAGE_TYPE_LC),
    _PU(AC_FULL_SCREEN_VIEW, AC_full_screen_view,
        "AC full screen view",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_NORMAL_VIEW, AC_normal_view,
        "AC normal view",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_VIEW_TOGGLE, AC_view_toggle,
        "AC view toggle",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SCROLL_UP, AC_scroll_up,
        "AC scroll up",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SCROLL_DOWN, AC_scroll_down,
        "AC scroll down",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SCROLL, AC_scroll,
        "AC scroll",
        HIDRD_USAGE_TYPE_LC),
    _PU(AC_PAN_LEFT, AC_pan_left,
        "AC pan left",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PAN_RIGHT, AC_pan_right,
        "AC pan right",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PAN, AC_pan,
        "AC pan",
        HIDRD_USAGE_TYPE_LC),
    _PU(AC_NEW_WINDOW, AC_new_window,
        "AC new window",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_TILE_HORIZ, AC_tile_horiz,
        "AC tile horizontally",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_TILE_VERT, AC_tile_vert,
        "AC tile vertically",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FORMAT, AC_format,
        "AC format",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_EDIT, AC_edit,
        "AC edit",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_BOLD, AC_bold,
        "AC bold",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ITALICS, AC_italics,
        "AC italics",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_UNDERLINE, AC_underline,
        "AC underline",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_STRIKETHROUGH, AC_strikethrough,
        "AC strikethrough",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SUBSCRIPT, AC_subscript,
        "AC subscript",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SUPERSCRIPT, AC_superscript,
        "AC superscript",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ALL_CAPS, AC_all_caps,
        "AC all caps",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ROTATE, AC_rotate,
        "AC rotate",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_RESIZE, AC_resize,
        "AC resize",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FLIP_HORIZ, AC_flip_horiz,
        "AC flip horizontal",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FLIP_VERT, AC_flip_vert,
        "AC flip vertical",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_MIRROR_HORIZ, AC_mirror_horiz,
        "AC mirror horizontal",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_MIRROR_VERT, AC_mirror_vert,
        "AC mirror vertical",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FONT_SELECT, AC_font_select,
        "AC font select",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FONT_COLOR, AC_font_color,
        "AC font color",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FONT_SIZE, AC_font_size,
        "AC font size",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_JUSTIFY_LEFT, AC_justify_left,
        "AC justify left",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_JUSTIFY_CENTER_H, AC_justify_center_H,
        "AC justify center H",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_JUSTIFY_RIGHT, AC_justify_right,
        "AC justify right",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_JUSTIFY_BLOCK_H, AC_justify_block_H,
        "AC justify block H",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_JUSTIFY_TOP, AC_justify_top,
        "AC justify top",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_JUSTIFY_CENTER_V, AC_justify_center_V,
        "AC justify center V",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_JUSTIFY_BOTTOM, AC_justify_bottom,
        "AC justify bottom",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_JUSTIFY_BLOCK_V, AC_justify_block_V,
        "AC justify block V",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INDENT_DEC, AC_indent_dec,
        "AC indent decrease",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INDENT_INC, AC_indent_inc,
        "AC indent increase",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_NUMBERED_LIST, AC_numbered_list,
        "AC numbered list",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_RESTART_NUMBERING, AC_restart_numbering,
        "AC restart numbering",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_BULLETED_LIST, AC_bulleted_list,
        "AC bulleted list",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PROMOTE, AC_promote,
        "AC promote",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_DEMOTE, AC_demote,
        "AC demote",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_YES, AC_yes,
        "AC yes",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_NO, AC_no,
        "AC no",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_CANCEL, AC_cancel,
        "AC cancel",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_CATALOG, AC_catalog,
        "AC catalog",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_BUY_OR_CHECKOUT, AC_buy_or_checkout,
        "AC buy/checkout",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ADD_TO_CART, AC_add_to_cart,
        "AC add to cart",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_EXPAND, AC_expand,
        "AC expand",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_EXPAND_ALL, AC_expand_all,
        "AC expand all",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_COLLAPSE, AC_collapse,
        "AC collapse",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_COLLAPSE_ALL, AC_collapse_all,
        "AC collapse all",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PRINT_PREVIEW, AC_print_preview,
        "AC print preview",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PASTE_SPECIAL, AC_paste_special,
        "AC paste special",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INSERT_MODE, AC_insert_mode,
        "AC insert mode",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_DELETE, AC_delete,
        "AC delete",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_LOCK, AC_lock,
        "AC lock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_UNLOCK, AC_unlock,
        "AC unlock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_PROTECT, AC_protect,
        "AC protect",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_UNPROTECT, AC_unprotect,
        "AC unprotect",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ATTACH_COMMENT, AC_attach_comment,
        "AC attach comment",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_DELETE_COMMENT, AC_delete_comment,
        "AC delete comment",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_VIEW_COMMENT, AC_view_comment,
        "AC view comment",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_WORD, AC_select_word,
        "AC select word",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_SENTENCE, AC_select_sentence,
        "AC select sentence",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_PARAGRAPH, AC_select_paragraph,
        "AC select paragraph",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_COLUMN, AC_select_column,
        "AC select column",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_ROW, AC_select_row,
        "AC select row",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_TABLE, AC_select_table,
        "AC select table",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_OBJECT, AC_select_object,
        "AC select object",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_REDO_OR_REPEAT, AC_redo_or_repeat,
        "AC redo/repeat",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SORT, AC_sort,
        "AC sort",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SORT_ASCENDING, AC_sort_ascending,
        "AC sort ascending",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SORT_DESCENDING, AC_sort_descending,
        "AC sort descending",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FILTER, AC_filter,
        "AC filter",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SET_CLOCK, AC_set_clock,
        "AC set clock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_VIEW_CLOCK, AC_view_clock,
        "AC view clock",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SELECT_TIME_ZONE, AC_select_time_zone,
        "AC select time zone",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_EDIT_TIME_ZONES, AC_edit_time_zones,
        "AC edit time zones",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SET_ALARM, AC_set_alarm,
        "AC set alarm",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_CLEAR_ALARM, AC_clear_alarm,
        "AC clear alarm",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SNOOZE_ALARM, AC_snooze_alarm,
        "AC snooze alarm",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_RESET_ALARM, AC_reset_alarm,
        "AC reset alarm",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SYNCHRONIZE, AC_synchronize,
        "AC synchronize",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SEND_OR_RECEIVE, AC_send_or_receive,
        "AC send/receive",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SEND_TO, AC_send_to,
        "AC send to",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_REPLY, AC_reply,
        "AC reply",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_REPLY_ALL, AC_reply_all,
        "AC reply all",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_FORWARD_MSG, AC_forward_msg,
        "AC forward msg",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SEND, AC_send,
        "AC send",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_ATTACH_FILE, AC_attach_file,
        "AC attach file",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_UPLOAD, AC_upload,
        "AC upload",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_DOWNLOAD_AND_SAVE_AS, AC_download_and_save_as,
        "AC download (save target as)",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SET_BORDERS, AC_set_borders,
        "AC set borders",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INSERT_ROW, AC_insert_row,
        "AC insert row",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INSERT_COLUMN, AC_insert_column,
        "AC insert column",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INSERT_FILE, AC_insert_file,
        "AC insert file",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INSERT_PICTURE, AC_insert_picture,
        "AC insert picture",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INSERT_OBJECT, AC_insert_object,
        "AC insert object",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_INSERT_SYMBOL, AC_insert_symbol,
        "AC insert symbol",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SAVE_AND_CLOSE, AC_save_and_close,
        "AC save and close",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_RENAME, AC_rename,
        "AC rename",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_MERGE, AC_merge,
        "AC merge",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_SPLIT, AC_split,
        "AC split",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_DISRIBUTE_HORIZ, AC_disribute_horiz,
        "AC disribute horizontally",
        HIDRD_USAGE_TYPE_SEL),
    _PU(AC_DISTRIBUTE_VERT, AC_distribute_vert,
        "AC distribute vertically",
        HIDRD_USAGE_TYPE_SEL),

#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_digitizer[70] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(DIGITIZER_##_TOKEN, _token, _name, _type_set)

    _PU(DIGITIZER, digitizer,
        "digitizer",
        HIDRD_USAGE_TYPE_CA),
    _PU(PEN, pen,
        "pen",
        HIDRD_USAGE_TYPE_CA),
    _PU(LIGHT_PEN, light_pen,
        "light pen",
        HIDRD_USAGE_TYPE_CA),
    _PU(TOUCHSCREEN, touchscreen,
        "touch screen",
        HIDRD_USAGE_TYPE_CA),
    _PU(TOUCHPAD, touchpad,
        "touch pad",
        HIDRD_USAGE_TYPE_CA),
    _PU(WHITEBOARD, whiteboard,
        "white board",
        HIDRD_USAGE_TYPE_CA),
    _PU(COORD_MEASURING_MACHINE, coord_measuring_machine,
        "coordinate measuring machine",
        HIDRD_USAGE_TYPE_CA),
    _PU(3D_DIGITIZER, 3D_digitizer,
        "3D digitizer",
        HIDRD_USAGE_TYPE_CA),
    _PU(STEREO_PLOTTER, stereo_plotter,
        "stereo plotter",
        HIDRD_USAGE_TYPE_CA),
    _PU(ARTICULATED_ARM, articulated_arm,
        "articulated arm",
        HIDRD_USAGE_TYPE_CA),
    _PU(ARMATURE, armature,
        "armature",
        HIDRD_USAGE_TYPE_CA),
    _PU(MULTIPOINT_DIGITIZER, multipoint_digitizer,
        "multiple point digitizer",
        HIDRD_USAGE_TYPE_CA),
    _PU(FREE_SPACE_WAND, free_space_wand,
        "free space wand",
        HIDRD_USAGE_TYPE_CA),
    _PU(CONFIGURATION, configuration,
        "configuration",
        HIDRD_USAGE_TYPE_CA),
    _PU(STYLUS, stylus,
        "stylus",
        HIDRD_USAGE_TYPE_CL),
    _PU(PUCK, puck,
        "puck",
        HIDRD_USAGE_TYPE_CL),
    _PU(FINGER, finger,
        "finger",
        HIDRD_USAGE_TYPE_CL),
    _PU(DEVICE_SETTINGS, device_settings,
        "device settings",
        HIDRD_USAGE_TYPE_CL),
    _PU(TIP_PRESSURE, tip_pressure,
        "tip pressure",
        HIDRD_USAGE_TYPE_DV),
    _PU(BARREL_PRESSURE, barrel_pressure,
        "barrel pressure",
        HIDRD_USAGE_TYPE_DV),
    _PU(IN_RANGE, in_range,
        "in range",
        HIDRD_USAGE_TYPE_MC),
    _PU(TOUCH, touch,
        "touch",
        HIDRD_USAGE_TYPE_MC),
    _PU(UNTOUCH, untouch,
        "untouch",
        HIDRD_USAGE_TYPE_OSC),
    _PU(TAP, tap,
        "tap",
        HIDRD_USAGE_TYPE_OSC),
    _PU(QUALITY, quality,
        "quality",
        HIDRD_USAGE_TYPE_DV),
    _PU(DATA_VALID, data_valid,
        "data valid",
        HIDRD_USAGE_TYPE_MC),
    _PU(TRANSDUCER_INDEX, transducer_index,
        "transducer index",
        HIDRD_USAGE_TYPE_DV),
    _PU(TABLET_FUNCTION_KEYS, tablet_function_keys,
        "tablet function keys",
        HIDRD_USAGE_TYPE_CL),
    _PU(PROGRAM_CHANGE_KEYS, program_change_keys,
        "program change keys",
        HIDRD_USAGE_TYPE_CL),
    _PU(BATTERY_STRENGTH, battery_strength,
        "battery strength",
        HIDRD_USAGE_TYPE_DV),
    _PU(INVERT, invert,
        "invert",
        HIDRD_USAGE_TYPE_MC),
    _PU(X_TILT, X_tilt,
        "X tilt",
        HIDRD_USAGE_TYPE_DV),
    _PU(Y_TILT, Y_tilt,
        "Y tilt",
        HIDRD_USAGE_TYPE_DV),
    _PU(AZIMUTH, azimuth,
        "azimuth",
        HIDRD_USAGE_TYPE_DV),
    _PU(ALTITUDE, altitude,
        "altitude",
        HIDRD_USAGE_TYPE_DV),
    _PU(TWIST, twist,
        "twist",
        HIDRD_USAGE_TYPE_DV),
    _PU(TIP_SWITCH, tip_switch,
        "tip switch",
        HIDRD_USAGE_TYPE_MC),
    _PU(SECONDARY_TIP_SWITCH, secondary_tip_switch,
        "secondary tip switch",
        HIDRD_USAGE_TYPE_MC),
    _PU(BARREL_SWITCH, barrel_switch,
        "barrel switch",
        HIDRD_USAGE_TYPE_MC),
    _PU(ERASER, eraser,
        "eraser",
        HIDRD_USAGE_TYPE_MC),
    _PU(TABLET_PICK, tablet_pick,
        "tablet pick",
        HIDRD_USAGE_TYPE_MC),
    _PU(TOUCH_VALID, touch_valid,
        "touch valid",
        HIDRD_USAGE_TYPE_MC),
    _PU(WIDTH, width,
        "width",
        HIDRD_USAGE_TYPE_DV),
    _PU(HEIGHT, height,
        "height",
        HIDRD_USAGE_TYPE_DV),
    _PU(CONTACT_IDENTIFIER, contact_identifier,
        "contact identifier",
        HIDRD_USAGE_TYPE_DV),
    _PU(DEVICE_MODE, device_mode,
        "device input mode",
        HIDRD_USAGE_TYPE_DV),
    _PU(DEVICE_IDENTIFIER, device_identifier,
        "device identifier",
        HIDRD_USAGE_TYPE_DV),
    _PU(CONTACT_COUNT, contact_count,
        "contact count",
        HIDRD_USAGE_TYPE_DV),
    _PU(CONTACT_COUNT_MAXIMUM, contact_count_maximum,
        "contact count maximum",
        HIDRD_USAGE_TYPE_SV),
    _PU(SCAN_TIME, scan_time,
        "scan time",
        HIDRD_USAGE_TYPE_DV),
    _PU(SECONDARY_BARREL_SWITCH, secondary_barrel_switch,
        "secondary barrel switch",
        HIDRD_USAGE_TYPE_MC),
    _PU(TRANSDUCER_SERIAL_NUMBER, transducer_serial_number,
        "transducer serial number",
        HIDRD_USAGE_TYPE_SV),
    _PU(PREFERRED_COLOR, preferred_color,
        "preferred color",
        HIDRD_USAGE_TYPE_DV),
    _PU(PREFERRED_COLOR_LOCKED, preferred_color_locked,
        "preferred color is locked",
        HIDRD_USAGE_TYPE_MC),
    _PU(PREFERRED_LINE_WIDTH, preferred_line_width,
        "preferred line width",
        HIDRD_USAGE_TYPE_DV),
    _PU(PREFERRED_LINE_WIDTH_LOCKED, preferred_line_width_locked,
        "preferred line width is locked",
        HIDRD_USAGE_TYPE_MC),
    _PU(PREFERRED_LINE_STYLE, preferred_line_style,
        "preferred line style",
        HIDRD_USAGE_TYPE_NARY),
    _PU(PREFERRED_LINE_STYLE_LOCKED, preferred_line_style_locked,
        "preferred line style is locked",
        HIDRD_USAGE_TYPE_MC),
    _PU(INK, ink,
        "ink",
        HIDRD_USAGE_TYPE_SEL),
    _PU(PENCIL, pencil,
        "pencil",
        HIDRD_USAGE_TYPE_SEL),
    _PU(HIGHLIGHTER, highlighter,
        "highlighter",
        HIDRD_USAGE_TYPE_SEL),
    _PU(CHISEL_MARKER, chisel_marker,
        "chisel marker",
        HIDRD_USAGE_TYPE_SEL),
    _PU(BRUSH, brush,
        "brush",
        HIDRD_USAGE_TYPE_SEL),
    _PU(NO_PREFERENCE, no_preference,
        "no preference",
        HIDRD_USAGE_TYPE_SEL),
    _PU(DIGITIZER_DIAGNOSTIC, digitizer_diagnostic,
        "digitizer diagnostic",
        HIDRD_USAGE_TYPE_CL),
    _PU(DIGITIZER_ERROR, digitizer_error,
        "digitizer error",
        HIDRD_USAGE_TYPE_NARY),
    _PU(ERR_NORMAL_STATUS, err_normal_status,
        "err normal status",
        HIDRD_USAGE_TYPE_SEL),
    _PU(ERR_TRANSDUCERS_EXCEEDED, err_transducers_exceeded,
        "err transducers exceeded",
        HIDRD_USAGE_TYPE_SEL),
    _PU(ERR_FULL_TRANS_FT_UNAVAIL, err_full_trans_ft_unavail,
        "err full transducer features unavailable",
        HIDRD_USAGE_TYPE_SEL),
    _PU(ERR_CHARGE_LOW, err_charge_low,
        "err charge low",
        HIDRD_USAGE_TYPE_SEL),

#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_pid[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(PID_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_unicode[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(UNICODE_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_alnum_display[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(ALNUM_DISPLAY_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_medical[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(MEDICAL_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_monitor[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(MONITOR_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_monitor_enum[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(MONITOR_ENUM_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_monitor_vesa_vcp[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(MONITOR_VESA_VCP_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_power_device[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(POWER_DEVICE_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_power_batsys[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(POWER_BATSYS_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_pos_bcs[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(POS_BCS_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_pos_scale[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(POS_SCALE_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_pos_msr[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(POS_MSR_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_camera[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(CAMERA_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

const hidrd_usage_id_desc   hidrd_usage_id_desc_list_arcade[0] = {
#define _PU(_TOKEN, _token, _name, _type_set) \
    _U(ARCADE_##_TOKEN, _token, _name, _type_set)


#undef _PU
};

#undef _U

#undef _U_NAME
#undef _U_TOKEN
