/*
 * vim:nomodifiable
 *
 * ****************** DO NOT EDIT ********************
 * This file is autogenerated from page_desc_list.c.m4
 * ***************************************************
 */
/** @file
 * @brief HID report descriptor - usage ID description lists
 *
 * Copyright (C) 2010 Nikolai Kondrashov
 *
 * This file is part of hidrd.
 *
 * Hidrd is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Hidrd is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with hidrd; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * @author Nikolai Kondrashov <spbnick@gmail.com>
 */

#include <strings.h>
#include "hidrd/cfg.h"
#include "hidrd/util/str.h"
#include "hidrd/util/tkn.h"
#include "hidrd/usage/id_desc_list.h"
#include "hidrd/usage/page_desc_list.h"

const hidrd_usage_page_desc hidrd_usage_page_desc_list[28] = {
#ifdef HIDRD_WITH_TOKENS
#define _P_TOKEN(_token)    .token = _token,
#else
#define _P_TOKEN(_token)
#endif

#ifdef HIDRD_WITH_NAMES
#define _P_NAME(_name)      .name = _name,
#else
#define _P_NAME(_name)
#endif

#define _P(_TOKEN, _Token, _token, _name) \
    {.value = HIDRD_USAGE_PAGE_##_TOKEN,                    \
     _P_TOKEN(#_Token) _P_NAME(_name)                       \
     .id_list = hidrd_usage_id_desc_list_##_token,          \
     .id_num = sizeof(hidrd_usage_id_desc_list_##_token) /  \
              sizeof(*hidrd_usage_id_desc_list_##_token)}

    _P(UNDEFINED, undefined, undefined, "undefined"),

    _P(DESKTOP, desktop, desktop,
       "generic desktop controls"),
    _P(SIMULATION, simulation, simulation,
       "simulation controls"),
    _P(VR, VR, vr,
       "virtual reality controls"),
    _P(SPORT, sport, sport,
       "sport controls"),
    _P(GAME, game, game,
       "game controls"),
    _P(DEVICE, device, device,
       "generic device controls"),
    _P(KEYBOARD, keyboard, keyboard,
       "keyboard/keypad"),
    _P(LED, LED, led,
       "LEDs"),
    _P(BUTTON, button, button,
       "button"),
    _P(ORDINAL, ordinal, ordinal,
       "ordinal"),
    _P(TELEPHONY, telephony, telephony,
       "telephony"),
    _P(CONSUMER, consumer, consumer,
       "consumer"),
    _P(DIGITIZER, digitizer, digitizer,
       "digitizer"),
    _P(PID, PID, pid,
       "physical interface device"),
    _P(UNICODE, Unicode, unicode,
       "Unicode"),
    _P(ALNUM_DISPLAY, alnum_display, alnum_display,
       "alphanumeric display"),
    _P(MEDICAL, medical, medical,
       "medical"),
    _P(MONITOR, monitor, monitor,
       "USB monitor"),
    _P(MONITOR_ENUM, monitor_enum, monitor_enum,
       "monitor enumerated values"),
    _P(MONITOR_VESA_VCP, monitor_VESA_VCP, monitor_vesa_vcp,
       "monitor VESA virtual control panel"),
    _P(POWER_DEVICE, power_device, power_device,
       "power device"),
    _P(POWER_BATSYS, power_batsys, power_batsys,
       "power battery system"),
    _P(POS_BCS, POS_BCS, pos_bcs,
       "POS devices - bar code scanner"),
    _P(POS_SCALE, POS_scale, pos_scale,
       "POS devices - scale"),
    _P(POS_MSR, POS_MSR, pos_msr,
       "POS devices - magnetic stripe reader"),
    _P(CAMERA, camera, camera,
       "camera control"),
    _P(ARCADE, arcade, arcade,
       "arcade"),

#undef _P

#undef _P_NAME
#undef _P_TOKEN
};


const hidrd_usage_page_desc *
hidrd_usage_page_desc_list_lkp_by_value(hidrd_usage_page value)
{
    const hidrd_usage_page_desc    *p = hidrd_usage_page_desc_list;
    size_t                          i = sizeof(hidrd_usage_page_desc_list) /
                                        sizeof(*hidrd_usage_page_desc_list);

    assert(hidrd_usage_page_valid(value));

    for (; i > 0; i--, p++)
        if (p->value == value)
            return p;

    return NULL;
}


#ifdef HIDRD_WITH_TOKENS
const hidrd_usage_page_desc *
hidrd_usage_page_desc_list_lkp_by_token(const char *token)
{
    const hidrd_usage_page_desc    *p = hidrd_usage_page_desc_list;
    size_t                          i = sizeof(hidrd_usage_page_desc_list) /
                                        sizeof(*hidrd_usage_page_desc_list);

    assert(hidrd_tkn_valid(token));

    for (; i > 0; i--, p++)
        if (strcasecmp(p->token, token) == 0)
            return p;

    return NULL;
}
#endif /* HIDRD_WITH_TOKENS */


